COMMENTED_OUT = 0

;----------------------------------------------------
  ;macros

  !macro check_same_page_start {
  !set page_check_page_addr = * & $ff00
  }

  !macro check_same_page_end {
  !if (page_check_page_addr != ( * & $ff00)) {
    !error "not the same page"
  }
  }

;----------------------------------------------------
  ;in a value
  ;in x first page
  ;in y number of pages

  ;changed : x,y

  !ifdef COMMENTED_OUT {
        
memset:
  stx memset_addr+2
  ldx #$00
memset_addr:
  sta $ff00,x
  inx
  bne memset_addr
  inc memset_addr+2
  dey
  bne memset_addr
  rts
  }
;----------------------------------------------------

  ;in a source page
  ;in x dest page
  ;in y number of pages

  ;changed : a,x,y

  !ifdef COMMENTED_OUT {

memcpy:
  sta memcpy_src_addr+2
  stx memcpy_dst_addr+2
  ldx #$00
memcpy_src_addr:
  lda $ff00,x
memcpy_dst_addr:
  sta $ff00,x
  inx
  bne memcpy_src_addr
  inc memcpy_src_addr+2
  inc memcpy_dst_addr+2
  dey
  bne memcpy_src_addr
  rts
  }
;----------------------------------------------------
waitvbl:
- bit $d011
        bpl -
- bit $d011
  bmi -
        rts        

;----------------------------------------------------
  !ifdef COMMENTED_OUT {
waitd012:
  ;in a line to wait
  ;changed: -
  cmp $d012
  bne waitd012
  rts
  }

;----------------------------------------------------

waitstable:
  ;stabilize raster position
  ;changed: a
  lda #62
  sec
  sbc $dd06
  sta waitstablebpl+1
waitstablebpl:
  bpl *
  ;!for i, 60 {
  ;!byte $c9
  ;}
!fill 60, $c9
  bit $ea
  rts


;----------------------------------------------------

init_stable_timer:
  ; make a stable timer on CIA A
  ; this is needed for stable interrupts
  ; must be done only once at start

  ;changed : a,x,y

  ; no interrupts please in this function !
  ; reset timer
  ldx #$00
  ;lda #$7f
  ;sta $dd0d,x
  ;sta $dc0d,x
  lda #%00000000
  sta $dd0f
  ; 63 to zero because of 63 cycles per line
  lda #<(63-1)
  sta $dd06
  lda #>(63-1)
  sta $dd07
  ; but not start it yet !

  +check_same_page_start
  ; get out of bad line area
- lda $d011
  bmi -
- lda $d011
  bpl -
  lda $d012
- cmp $d012
  beq -
  lda (00,x)
  ldy #%00010001
again:
  ;make a loop with 62 cycles
  ldx #10   ; 2
- dex   ; 2
  bne -     ; 3 (last one 2) -> 2+(10*5)-1
  lda $d012 ; 4
  ;if the compare is not equal the first time, we are in sync with VIC !
  cmp $d012 ; 4
  beq again ; 3 -> 4+4+3 + (2+(10*5)-1) = 62 (63-1 !)
  ; start the timer now
  lda (00,x)
  lda (00,x)
  lda (00),y
  nop
        sty $dd0f
  +check_same_page_end
  rts

start_standard_irq:
  pha
  txa
  pha
  tya
  pha
  rts
  
end_standard_irq:
  asl $d019
  pla
  tay
  pla
  tax
  pla
  rti
  
wait_border:
  lda #$fe
  jsr waitd012
  rts  