;compile to this filename
!to "bin\strange-reflection.prg",cbm
savea                 = $02
savex                 = $03
savey                 = $04
temp_y_scroller       = $05 

textpointer1          = $06
                       ;$07
                       
;### VIC CONFIC Variables ###
SCREEN_MEM          = $0400

;### System Variables ###
SCREEN_COLOR        = $D800
VIC_CHAR_CONFIG     = $D011
VIC_COLOR_CONFIG    = $D016
VIC_BANK_CONFIG     = $D018
BORDER_COLOR        = $D020
BACKGROUND_COLOR    = $D021
MC_BACKGROUND_COL_1 = $D022 ;53282  34  Multicolor Background 1 on Extended Color Mode (0..15)
MC_BACKGROUND_COL_2 = $D023 ;53283  35  Multicolor Background 2 on Extended Color Mode (0..15)
FONT_MEM            = $2000

*=$0801                    ; sets file load address to $0801
  ;org $0801              ; sets compile address to $0801
  !byte $0b,$08           ; Address of next BASIC instruction
  !byte $C0,$07           ; Line number 2016
  !byte $9e               ; SYS-token
  !text " 2062"           ; 2062 in ASCII
  !byte $00,$00,$00       ; BASIC program end

  sei
  lda #$7f
  sta $dc0d  ;disable timer interrupts which can be generated by the two CIA chips
  sta $dd0d  ;the kernal uses such an interrupt to flash the cursor and scan the keyboard, so we better
             ;stop it.

  lda $dc0d  ;by reading this two registers we negate any pending CIA irqs.
  lda $dd0d  ;if we don't do this, a pending CIA irq might occur after we finish setting up our irq.
             ;we don't want that to happen.


  lda #$35   ;we turn off the BASIC and KERNAL rom here
  sta $01    ;the cpu now sees RAM everywhere except at $d000-$e000, where still the registers of
             ;SID/VICII/etc are visible
  
;  jsr animate_hires
  jsr init_stable_timer
  
  lax #$00
  tay
  jsr sidinit

  jsr startscreenfade
  jsr init_colors  
  jsr scroll_init
  
  jsr flip_logo  
  ;jsr wait_border
  jsr set_chars_speedcode
  
.loop  
  lda current_task
;------------  
  cmp #$01
  bne+
  lda #$00 
  sta current_task

  jsr reset_animation
  jsr wait_border  
  lda #$0c
  sta $d020
  sta $d021  
  jsr init_sprites  
  jsr irq_init
  jsr show_hires
  jmp .endloop

+
  cmp #$02
  bne+
  lda #$00 
  sta current_task  

  jsr flip_logo
  jsr wait_border 

  lda #$0e
  sta $d020
  sta $d021

  jsr irq_init2
  jsr show_water 
  jmp .endloop
  
+
.endloop  
  jmp .loop
  
current_task
!byte $01


*= $1000
sidinit:
sidplay = *+3 
; uses zp $f0 and $f1
!binary "bin\Hexadecimal.sid",, 0x7E

!source "framework.asm"
!source "irqs.asm"
!source "irqs2.asm"
!source "screenfade.asm"
!source "credits.asm"
!source "credit_sprites.asm"
!source "checkkey.asm"
!source "water_screen.asm"
!source "scroller.asm"
!source "scrolltext.asm"
!source "color_animation.asm"
!source "credit_chars_animation.asm"

*=$5000
;sprites:
!binary "bin\credits_overlay.bin",,

*=$5c00
credits_screen:
;!binary "bin\credits-hires-part.dd",, 2
!binary "bin\videomem-credits-hires-part.dd.PRG",, 2
*=$6000
credits_bitmap:
!binary "bin\bitmap-credits-hires-part.dd.PRG",, 2

*=$8000
fontdata:
  !binary "bin\18-mirror-fontdata.bin",,
*=$8800  
  !binary "bin\dycp-font-fontdata.bin",,  
  
* = $9000
clear_screen_speedcode:
  lda #$00
  !for POS = 0 TO 279
   sta SCREEN_ADDRESS + POS
  !end
  rts
  
*=$a000  
screendata:
  !binary "bin\18-mirror-screendata.bin" ,,

  


