!zone screenfade

tmp0 = $10

startscreenfade:
;  lda #$7f
;  sta $dc0d  ;disable timer interrupts which can be generated by the two CIA chips
;  sta $dd0d  ;the kernal uses such an interrupt to flash the cursor and scan the keyboard, so we better
;             ;stop it.
;
;  lda $dc0d  ;by reading this two registers we negate any pending CIA irqs.
;  lda $dd0d  ;if we don't do this, a pending CIA irq might occur after we finish setting up our irq.
;             ;we don't want that to happen.

  ;color fade     
  lda $d020  
  sta .config+2
  jsr fade_screen  
  
  ;char fade
  lda #$04 
  sta .config+1
  lda #$a0 
  sta .config+2
  jsr fade_screen  

  jsr wait_border  
  lda #$00
  jsr waitd012
  
  lda $d020
  sta $d021
  
  lda #$20
  ldx #$04
  ldy #$04
  jsr memset
  
  jsr wait_border  
  lda #$00
  jsr waitd012
  
  lda #$0c
  sta $d020
  sta $d021
  
  rts
  
.config  
  !byte $00 ;low (here of $d800)
  !byte $d8 ;high (here of $d800)
  !byte $00 ;fillvalue 

fade_screen
.reset_zp;                
  ldy #40
  ldx #0
- sty tmp0,x
  iny
  inx
  cpx #26
  bne -

  jmp .deleteloop
  
.deleteloop:   
  jsr wait_border
  lda #$00
  sta delpos+1
  lda #$04
  sta delpos+2
  ldy #0
  
delloop:    
  ldx tmp0,y
  cpx #40         
  bcs +
  lda #$a0
  
delpos:     
  sta $DEAD,x ;changed with selfmod
+ lda delpos+1
  clc
  adc #40
  sta delpos+1
  bcc +
  inc delpos+2
+ iny
  cpy #25
  bne delloop

  ldx #25
- lda tmp0,x
  beq +
  dec tmp0,x
+ dex
  bpl -

  lda tmp0+25
  bne .deleteloop
  
  rts
  



