!zone scroll
;textpointer1          = $06
                       ;$07

SCREEN_ADDRESS = screendata+(40*18)                       

scroll_init:
  ;copy to zp
  lda textpointer_position1
  sta+1 textpointer1
  lda textpointer_position1+1
  sta+1 textpointer1+1
  rts
  
scroll:
  dec .scrpos
  dec .scrpos ;scroll 2x speed
  lda .scrpos 
  cmp #%00011111
;  cmp #%00100111 ;enable 40 chars per line
  bne +  
  jsr .hardscroll
  lda #%00100111 
;  lda #%00101111 ;enable 40 chars per line 
  sta .scrpos
+  
  sta d016_cache
  ;repaint has to be done every frame
  jsr .repaint
  rts
  
.hardscroll:
  ;move the scrolltextpointer one further
  inc textpointer1
  bne +
  inc textpointer1+1
+
  ldy #$00
  ;look if the scrolltextpointer has to be reset
  lda (textpointer1),y
  cmp #$ff
  bne +
  jsr scroll_init
+  
  inc sinuspointerDIV1
  inc sinuspointerMOD1
  
  rts
  
.repaint  
  jsr clear_screen_speedcode
  
  ; move the sinuspointer
  ; this is the reason, that the values have to be doubled
  inc sinuspointerDIV1
  inc sinuspointerMOD1
  
  clc  
;line 1  
  ldy #$27
  sty temp_y_scroller 
- 
  ldy temp_y_scroller 
  tya
  clc
  
sinuspointerDIV1 = *+1
  adc TableDIV1,y
  tax

  lda (textpointer1), y
sinuspointerMOD1 = *+1  
  eor TableMOD1,y
  tay
  lda dycp_table1,y
  sta SCREEN_ADDRESS-1,x

  lda dycp_table2,y
  sta SCREEN_ADDRESS-1+40,x

  dec temp_y_scroller
  bne -

  rts

.scrpos:   
;  !byte %00101001 ;enable 40 chars per line
  !byte %00100001‬ 

textpointer_position1
  !byte <(text1-1)
  !byte >(text1-1)

d016_cache
!byte $00

; The Sinus is DIV and MOD through 8
;
; The MOD part is multiplied with 32
; So we can easy get the high position 
; char value  with an easy LDA,X
; 
; The DIV part is multiplied with 40 for
; line position this results in an easy STA,x
;
; If you print the lines in the order of apperiance,
; you can go one value higher than normaly, this
; pushes the text one pixelline deeper
; but do never go above 47
; DIV would be: 48 \ 8 = 6
; 6 * 40 = 240
; this would be added to the position on screen and stored in X
; so the max would be above 255 for an STA,X = error
; DIV would be: 47 \ 8 = 5
; 5 * 40 = 200 is max!

!align 255, $00
TableDIV1:
  !source "sinus_data/TableDIV1.asm" 
; needs to be doubled
  !source "sinus_data/TableDIV1.asm" 

TableMOD1:
  !source "sinus_data/TableMOD1.asm" 
; needs to be doubled
  !source "sinus_data/TableMOD1.asm" 
  
!align 255, $00
dycp_table1:
  !binary "bin/dycp-font-screendata.bin",32,(64*0)
  !binary "bin/dycp-font-screendata.bin",32,(64*1)
  !binary "bin/dycp-font-screendata.bin",32,(64*2)
  !binary "bin/dycp-font-screendata.bin",32,(64*3)
  !binary "bin/dycp-font-screendata.bin",32,(64*4)
  !binary "bin/dycp-font-screendata.bin",32,(64*5)
  !binary "bin/dycp-font-screendata.bin",32,(64*6)
  !binary "bin/dycp-font-screendata.bin",32,(64*7)

dycp_table2:
  !binary "bin/dycp-font-screendata.bin",32,(32+64*0)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*1)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*2)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*3)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*4)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*5)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*6)
  !binary "bin/dycp-font-screendata.bin",32,(32+64*7)  